/* -*- buffer-read-only: t -*- vi: set ro:
#line 636
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
#line 636
*/
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>

static size_t debug_handle;
/* This must be defined before including debug.h */
#define MF_SOURCE_NAME  debug_handle

#include "mailfromd.h"
#include "prog.h"
#include "builtin.h"

#line 15 "mbox.bi"
/* This file is part of Mailfromd.             -*- c -*-
#line 15
   Copyright (C) 2008, 2010-2011 Sergey Poznyakoff
#line 15

#line 15
   This program is free software; you can redistribute it and/or modify
#line 15
   it under the terms of the GNU General Public License as published by
#line 15
   the Free Software Foundation; either version 3, or (at your option)
#line 15
   any later version.
#line 15

#line 15
   This program is distributed in the hope that it will be useful,
#line 15
   but WITHOUT ANY WARRANTY; without even the implied warranty of
#line 15
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#line 15
   GNU General Public License for more details.
#line 15

#line 15
   You should have received a copy of the GNU General Public License
#line 15
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include "msg.h"

static size_t nmboxes = NMBOXES;

static struct mu_cfg_param mbox_cfg_param[] = {
	{ "max-open-mailboxes", mu_cfg_size, &nmboxes, 0, NULL,
	  N_("Maximum number of mailboxes to open simultaneously.") },
	{ NULL }
};

static int
do_close(void *item, void *data)
{
	bi_close_message(item);
	return 0;
}

static void
close_mbox(struct mf_mbox *mp)
{
	if (mp->mbox) {
		mu_mailbox_close(mp->mbox);
		mu_mailbox_destroy(&mp->mbox);
		mu_list_do(mp->msglist, do_close, NULL);
		mu_list_destroy(&mp->msglist);
		memset(mp, 0, sizeof mp[0]);
	}
}

static void *
alloc_mboxes()
{
	return xcalloc(nmboxes, sizeof(struct mf_mbox));
}

static void
destroy_mboxes(void *data)
{
	struct mf_mbox *mtab = data;
	struct mf_mbox *p;
	for (p = mtab; p < mtab + nmboxes; p++) {
		close_mbox(p);
	}
	free(mtab);
}


#line 63

#line 63
static int MBOXTAB_id;
#line 63 "mbox.bi"


static int
find_slot(struct mf_mbox *tab)
{
	int i;
	for (i = 0; i < nmboxes; i++)
		if (tab[i].mbox == NULL)
			return i;
	return -1;
}

/* number mailbox_open(string url) */
void
#line 76
bi_mailbox_open(eval_environ_t env)
#line 76

#line 76 "mbox.bi"
{
#line 76
	
#line 76

#line 76
long __bi_argcnt;
#line 76
char * url;
#line 76
        char * mode;
#line 76
        char * perms;
#line 76
        
#line 76
get_string_arg(env, 1, &url);
#line 76
        get_string_arg(env, 2, &mode);
#line 76
        get_string_arg(env, 3, &perms);
#line 76
        
#line 76
get_numeric_arg(env, 0, &__bi_argcnt);
#line 76
        adjust_stack(env, __bi_argcnt + 1);
#line 76

#line 76
	if (builtin_module_trace(BUILTIN_IDX_mbox))
#line 76
		prog_trace(env, "mailbox_open %s %s %s",url, ((__bi_argcnt > 1) ? mode : ""), ((__bi_argcnt > 2) ? perms : ""));;
#line 76

{
	int rc;
	int md;
	struct mf_mbox *mbtab = env_get_builtin_priv(env,MBOXTAB_id);
	struct mf_mbox *mp;
	int flags;
	char *p;

	md = find_slot(mbtab);
		if (!(md >= 0))
#line 86
			env_throw_bi(env, mfe_failure, "mailbox_open", _("no more mailboxes available"))
#line 88
;
	debug1(10, "opening mailbox %s", url);
	mp = mbtab + md;

	flags = 0;
	for (p = ((__bi_argcnt > 1) ? mode : "r"); *p; p++) {
		switch (*p) {
		case 'a':
			flags |= MU_STREAM_APPEND;
			break;
			
		case 'r':
			flags |= MU_STREAM_READ;
			break;
			
		case 'w':
			flags |= MU_STREAM_WRITE;
			break;
			
		case '+':
			if (flags & MU_STREAM_READ)
				flags |= MU_STREAM_WRITE;
			else if (flags & MU_STREAM_WRITE)
				/* FIXME: should truncate as well */
				flags |= MU_STREAM_READ|MU_STREAM_CREAT;
			else if (flags & MU_STREAM_APPEND) {
				flags |= MU_STREAM_RDWR | MU_STREAM_CREAT;
			} else
					env_throw_bi(env, mfe_range, "mailbox_open", _("incorrect mode near `%s'"),p);
#line 119
			break;

		default:
				env_throw_bi(env, mfe_range, "mailbox_open", _("incorrect mode near `%s'"),p);
#line 125
		}
	}

	/* FIXME: MU: This is ridiculous! */
	if ((flags & (MU_STREAM_READ|MU_STREAM_WRITE))
	    == (MU_STREAM_READ|MU_STREAM_WRITE)) {
		    flags &= ~(MU_STREAM_READ|MU_STREAM_WRITE);
		    flags |= MU_STREAM_RDWR;
	}
	    
	if ((__bi_argcnt > 2)) {
		/* If MU_STREAM_IRGRP is defined, the remaining three
#line 138
		   permissions flags are defined as well.
#line 138
		   FIXME: Remove ifdef when MU 2.0 is out. */
#ifdef MU_STREAM_IRGRP
		int f;
		const char *p;
			if (!(mu_parse_stream_perm_string(&f, ((__bi_argcnt > 1) ? mode : 0), &p)
#line 142
			  == 0))
#line 142
			env_throw_bi(env, mfe_range, "mailbox_open", /* FIXME: introduce mfe_inval? */
#line 142
			  _("invalid permissions (near %s)"),p)
#line 145
;
		flags |= f;
#else
			env_throw_bi(env, mfe_failure, "mailbox_open", _("this version of Mailutils does not support "
#line 148
			   "configurable mailbox permissions"));
#line 151
#endif
	}
		
	rc = mu_mailbox_create(&mp->mbox, url);
		if (!(rc == 0))
#line 155
			env_throw_bi(env, mfe_failure, "mailbox_open", _("cannot create mailbox `%s': %s"),url,mu_strerror(rc))
#line 158
;
	rc = mu_mailbox_open(mp->mbox, flags);
	if (rc) {
		mu_mailbox_destroy(&mp->mbox);
			env_throw_bi(env, mfe_failure, "mailbox_open", _("cannot open mailbox `%s': %s"),url,mu_strerror(rc));
#line 165
	}
	mu_list_create(&mp->msglist);
	
	
#line 168
do {
#line 168
  push(env, (STKVAL) (md));
#line 168
  return;
#line 168
} while (0);
}
}

/* void mailbox_close(number mbx) */
void
#line 173
bi_mailbox_close(eval_environ_t env)
#line 173

#line 173 "mbox.bi"
{
#line 173
	
#line 173

#line 173

#line 173
long  md;
#line 173
        
#line 173
get_numeric_arg(env, 0, &md);
#line 173
        
#line 173

#line 173
        adjust_stack(env, 1);
#line 173

#line 173
	if (builtin_module_trace(BUILTIN_IDX_mbox))
#line 173
		prog_trace(env, "mailbox_close %lu",md);;
#line 173

{
	struct mf_mbox *mbtab = env_get_builtin_priv(env,MBOXTAB_id);

		if (!(md >= 0 && md < nmboxes))
#line 177
			env_throw_bi(env, mfe_range, "mailbox_close", _("invalid mailbox descriptor"))
#line 179
;
	close_mbox(mbtab + md);
}
}

#line 195

	
/* number mailbox_messages_count(number mbx) */
void
#line 198
bi_mailbox_messages_count(eval_environ_t env)
#line 198

#line 198 "mbox.bi"
{
#line 198
	
#line 198

#line 198

#line 198
long  nmbx;
#line 198
        
#line 198
get_numeric_arg(env, 0, &nmbx);
#line 198
        
#line 198

#line 198
        adjust_stack(env, 1);
#line 198

#line 198
	if (builtin_module_trace(BUILTIN_IDX_mbox))
#line 198
		prog_trace(env, "mailbox_messages_count %lu",nmbx);;
#line 198

{
	size_t count;
	int rc;
	
#line 202
	struct mf_mbox *mbtab = env_get_builtin_priv(env,MBOXTAB_id);
#line 202
	struct mf_mbox *mp;
#line 202
			
#line 202
		if (!(nmbx >= 0 && nmbx < nmboxes))
#line 202
			env_throw_bi(env, mfe_range, "mailbox_messages_count", _("invalid mailbox descriptor"))
#line 202
;
#line 202
	mp = mbtab + nmbx;
#line 202
		if (!(mp->mbox))
#line 202
			env_throw_bi(env, mfe_failure, "mailbox_messages_count", _("mailbox not open"))
#line 202

#line 202
;
	
	rc = mu_mailbox_messages_count(mp->mbox, &count);
		if (!(rc == 0))
#line 205
			env_throw_bi(env, mfe_failure, "mailbox_messages_count", "%s",mu_strerror(rc))
#line 208
;
	
#line 209
do {
#line 209
  push(env, (STKVAL) (count));
#line 209
  return;
#line 209
} while (0);
}
}

/* number mailbox_get_message(number mbx, number msg-no) */
void
#line 214
bi_mailbox_get_message(eval_environ_t env)
#line 214

#line 214 "mbox.bi"
{
#line 214
	
#line 214

#line 214

#line 214
long  nmbx;
#line 214
        long  msgno;
#line 214
        
#line 214
get_numeric_arg(env, 0, &nmbx);
#line 214
        get_numeric_arg(env, 1, &msgno);
#line 214
        
#line 214

#line 214
        adjust_stack(env, 2);
#line 214

#line 214
	if (builtin_module_trace(BUILTIN_IDX_mbox))
#line 214
		prog_trace(env, "mailbox_get_message %lu %lu",nmbx, msgno);;
#line 214

{
	int rc;
	mu_message_t msg;
	
#line 218
	struct mf_mbox *mbtab = env_get_builtin_priv(env,MBOXTAB_id);
#line 218
	struct mf_mbox *mp;
#line 218
			
#line 218
		if (!(nmbx >= 0 && nmbx < nmboxes))
#line 218
			env_throw_bi(env, mfe_range, "mailbox_get_message", _("invalid mailbox descriptor"))
#line 218
;
#line 218
	mp = mbtab + nmbx;
#line 218
		if (!(mp->mbox))
#line 218
			env_throw_bi(env, mfe_failure, "mailbox_get_message", _("mailbox not open"))
#line 218

#line 218
;

	rc = mu_mailbox_get_message(mp->mbox, msgno, &msg);
		if (!(rc == 0))
#line 221
			env_throw_bi(env, mfe_failure, "mailbox_get_message", "%s",mu_strerror(rc))
#line 224
;
	rc = bi_message_register(env, mp->msglist, msg, 0);
		if (!(rc >= 0))
#line 226
			env_throw_bi(env, mfe_failure, "mailbox_get_message", _("no more message slots available"))
#line 228
;
	
#line 229
do {
#line 229
  push(env, (STKVAL) (rc));
#line 229
  return;
#line 229
} while (0);
}
}

/* void mailbox_append_message(number mbx, number msg-no) */
void
#line 234
bi_mailbox_append_message(eval_environ_t env)
#line 234

#line 234 "mbox.bi"
{
#line 234
	
#line 234

#line 234

#line 234
long  nmbx;
#line 234
        long  msgno;
#line 234
        
#line 234
get_numeric_arg(env, 0, &nmbx);
#line 234
        get_numeric_arg(env, 1, &msgno);
#line 234
        
#line 234

#line 234
        adjust_stack(env, 2);
#line 234

#line 234
	if (builtin_module_trace(BUILTIN_IDX_mbox))
#line 234
		prog_trace(env, "mailbox_append_message %lu %lu",nmbx, msgno);;
#line 234

{
	int rc;
	mu_message_t msg;
	
#line 238
	struct mf_mbox *mbtab = env_get_builtin_priv(env,MBOXTAB_id);
#line 238
	struct mf_mbox *mp;
#line 238
			
#line 238
		if (!(nmbx >= 0 && nmbx < nmboxes))
#line 238
			env_throw_bi(env, mfe_range, "mailbox_append_message", _("invalid mailbox descriptor"))
#line 238
;
#line 238
	mp = mbtab + nmbx;
#line 238
		if (!(mp->mbox))
#line 238
			env_throw_bi(env, mfe_failure, "mailbox_append_message", _("mailbox not open"))
#line 238

#line 238
;

	msg = bi_message_from_descr(env, msgno);
	rc = mu_mailbox_append_message(mp->mbox, msg);
		if (!(rc == 0))
#line 242
			env_throw_bi(env, mfe_failure, "mailbox_append_message", _("cannot append message: %s"),mu_strerror(rc))
#line 245
;
}
}


#line 249
void
#line 249
mbox_init_builtin()
#line 249
{
#line 249
        debug_handle = debug_register("bi_mbox");
#line 249
	#line 63 "mbox.bi"
MBOXTAB_id = builtin_priv_register(alloc_mboxes, destroy_mboxes,
#line 63
NULL);
#line 76 "mbox.bi"
va_builtin_install_ex("mailbox_open", bi_mailbox_open, 0, dtype_number, 3, 2, 0|0, dtype_string, dtype_string, dtype_string);
#line 173 "mbox.bi"
va_builtin_install_ex("mailbox_close", bi_mailbox_close, 0, dtype_unspecified, 1, 0, 0|0, dtype_number);
#line 198 "mbox.bi"
va_builtin_install_ex("mailbox_messages_count", bi_mailbox_messages_count, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 214 "mbox.bi"
va_builtin_install_ex("mailbox_get_message", bi_mailbox_get_message, 0, dtype_number, 2, 0, 0|0, dtype_number, dtype_number);
#line 234 "mbox.bi"
va_builtin_install_ex("mailbox_append_message", bi_mailbox_append_message, 0, dtype_unspecified, 2, 0, 0|0, dtype_number, dtype_number);

#line 249 "mbox.bi"
	
#line 249
	 mf_add_runtime_params(mbox_cfg_param);
#line 249
	 
#line 249
}
#line 251

#line 627 "../../mfd/builtin/snarf.m4"

#line 627

